from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import String, File, Boolean

Anvi_Import_Functions_V0_1_0 = CommandToolBuilder(tool="anvi_import_functions", base_command=["anvi-import-functions"], inputs=[ToolInput(tag="in_contigs_db", input_type=String(optional=True), prefix="--contigs-db", doc=InputDocumentation(doc="Anvi'o contigs database generated by 'anvi-gen-\ncontigs-database' (default: None)")), ToolInput(tag="in_parser", input_type=File(optional=True), prefix="--parser", doc=InputDocumentation(doc="Parser to make sense of the input files (if you need\none). There are currently 1 parsers readily available:\n['interproscan']. IT IS OK if you do not select a\nparser if you have a standard, TAB-delimited input\nfile for funcitonal annotation of genes. If this is\nnot like 2018 and everything is already outdated, you\nshould be able to go to this address and learn\neverything you need like a boss:\nhttp://merenlab.org/2016/06/18/importing-functions/\n(default: None)")), ToolInput(tag="in_s_one_more", input_type=File(optional=True), prefix="-i", doc=InputDocumentation(doc="(S) [FILE(S) ...], --input-files FILE(S) [FILE(S) ...]\nOne or more input files should follow this parameter.\nThe way these files will be handled will depend on\nwhich parser you selected (if you did select any).\n(default: None)")), ToolInput(tag="in_drop_previous_annotations", input_type=Boolean(optional=True), prefix="--drop-previous-annotations", doc=InputDocumentation(doc="Use this flag if you want anvi'o to remove ALL\nprevious functional annotations for your genes, and\nthen import the new data. The default behavior will\nadd any annotation source into the db incrementally\nunless there are already annotations from this source.\nIn which case, it will first remove previous\nannotations for that source only (i.e., if source X is\nboth in the db and in the incoming annotations data,\nit will replace the content of source X in the db).\n(default: False)")), ToolInput(tag="in_functions", input_type=String(), position=0, doc=InputDocumentation(doc="🍺 More on `anvi-import-functions`:"))], outputs=[], container="quay.io/biocontainers/anvio-minimal:7--py_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Anvi_Import_Functions_V0_1_0().translate("wdl")

